// Copyright (C) 2003 Daisuke Arai <darai@users.sourceforge.jp>
// 
// This program is part of Protra.
//
// Protra is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
// 
// $Id: ContextToken.cs,v 1.2 2007-12-27 08:34:39 panacoran Exp $

using System;
using System.Text.RegularExpressions;

namespace Protra.Lib.Lang
{
	/// <summary>
	/// Contextにおける個々のトークンを表すクラスです。
	/// ContextのMementoでもあります。
	/// </summary>
	public class ContextToken
	{
		// 予約語のリスト
		private string[] registeredWords
			= {	"int", "float", "string", "null", "if", "else",  "elsif",
				"while", "def", "end", "return", "break", "continue" };
		private string[] typeWords
			= { "int", "float", "string" };

		/// <summary>
		/// トークンの実体
		/// </summary>
		private string token;
		/// <summary>
		/// トークンの属すファイル
		/// </summary>
		private string file;
		/// <summary>
		/// 次のトークンの存在する行
		/// </summary>
		private int line;
		/// <summary>
		/// 次のトークンの開始位置
		/// </summary>
		private int pos;
		
		/// <summary>
		/// コンストラクタ
		/// </summary>
		/// <param name="token">トークン</param>
		/// <param name="file">トークンの属すファイル</param>
		/// <param name="line">トークンの存在する行</param>
		/// <param name="pos">トークンの開始位置</param>
		public ContextToken(string token, string file, int line, int pos)
		{
			this.token = token;
			this.file = file;
			this.line = line;
			this.pos = pos;
		}

		/// <summary>
		/// トークンの文字列を返します。
		/// </summary>
		/// <returns>トークンの文字列</returns>
		public override string ToString()
		{
			return token;
		}

		/// <summary>
		/// トークンの属するファイル名を取得します。
		/// </summary>
		public string FileName
		{
			get { return file; }
		}

		/// <summary>
		/// 次のトークンの存在する行番号を取得します。
		/// </summary>
		public int Line
		{
			get { return line; }
		}

		/// <summary>
		/// 次のトークンの開始位置を取得します。
		/// </summary>
		public int Position
		{
			get { return pos; }
		}

		/// <summary>
		/// トークンが予約語であるかどうかを示す論理値を取得します。
		/// </summary>
		public bool IsRegisteredWord
		{
			get
			{
				if(token == null)
					return false;
				for(int i = 0; i < registeredWords.Length; i++)
					if(token == registeredWords[i])
						return true;
				return false;
			}
		}

		/// <summary>
		/// トークンが名前であるかどうかを示す論理値を取得します。
		/// </summary>
		public bool IsName
		{
			get
			{
				if(token == null)
					return false;
				if(IsRegisteredWord)
					return false;
				Regex regex = new Regex(@"^[A-Za-z][A-Za-z0-9_]*$|^\$[A-Za-z0-9_]+$");
				return regex.IsMatch(token);
			}
		}

		/// <summary>
		/// トークンが変数の名前であるかどうかを示す論理値を取得します。
		/// </summary>
		public bool IsVariableName
		{
			get
			{
				if(token == null)
					return false;
				if(IsRegisteredWord)
					return false;
				Regex regex = new Regex(@"^\$[A-Za-z0-9_]+$|^[a-z][A-Za-z0-9_]*$");
				return regex.IsMatch(token);
			}
		}

		/// <summary>
		/// トークンがグローバル変数の名前であるかどうかを示す論理値を取得します。
		/// </summary>
		public bool IsGlobalVariableName
		{
			get
			{
				if(token == null)
					return false;
				Regex regex = new Regex(@"^\$[A-Za-z0-9_]+$");
				return regex.IsMatch(token);
			}
		}

		/// <summary>
		/// トークンがローカル変数の名前であるかどうかを示す論理値を取得します。
		/// </summary>
		public bool IsLocalVariableName
		{
			get
			{
				if(token == null)
					return false;
				if(IsRegisteredWord)
					return false;
				Regex regex = new Regex(@"^[a-z][A-Za-z0-9_]*$");
				return regex.IsMatch(token);
			}
		}

		/// <summary>
		/// トークンが関数名であるかどうかを示す論理値を取得します。
		/// </summary>
		public bool IsFunctionName
		{
			get
			{
				if(token == null)
					return false;
				Regex regex = new Regex(@"^[A-Z][A-Za-z0-9_]*$");
				return regex.IsMatch(token);
			}
		}

		/// <summary>
		/// トークンがタイプであるかどうかを示す論理値を取得します。
		/// </summary>
		public bool IsType
		{
			get
			{
				if(token == null)
					return false;
				for(int i = 0; i < typeWords.Length; i++)
					if(token == typeWords[i])
						return true;
				return false;
			}
		}

		/// <summary>
		/// トークンがリテラルであるかどうかを示す論理値を取得します。
		/// </summary>
		public bool IsLiteral
		{
			get
			{
				if(token == null)
					return false;
				return IsInt || IsFloat || IsString || token == "null";
			}
		}


		/// <summary>
		/// トークンがint型のリテラルであるかどうかを示す論理値を取得します。
		/// </summary>
		public bool IsInt
		{
			get
			{
				if(token == null)
					return false;
				Regex regex = new Regex(@"^[1-9][0-9]*$|^0$");
				return regex.IsMatch(token);
			}
		}

		/// <summary>
		/// トークンがfloat型のリテラルであるかどうかを示す論理値を取得します。
		/// </summary>
		public bool IsFloat
		{
			get
			{
				if(token == null)
					return false;
				Regex regex = new Regex(@"^[1-9][0-9]*\.[0-9]+$|^0\.[0-9]+$");
				return regex.IsMatch(token);
			}
		}

		/// <summary>
		/// トークンがstring型のリテラルであるかどうかを示す論理値を取得します。
		/// </summary>
		public bool IsString
		{
			get
			{
				if(token == null)
					return false;
				Regex regex = new Regex(@"^""[^""]*""$");
				return regex.IsMatch(token);
			}
		}
	}
}
